#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_maximum  1.0
#property indicator_minimum  0.0

extern int    Trend.Period = 6;
extern bool   ShowArrows       = true;
extern string arrowsIdentifier = "K-J2_mod";
extern color  arrowsUpColor    = Lime;
extern color  arrowsDnColor    = Lime;
extern bool   AlertOn = FALSE;
extern bool   bar_0 = FALSE;

string gs_nothing_176 = "nothing";
int gi_80 = 0;
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double gda_96[][30];
datetime g_time_184;
int init() {
   IndicatorBuffers(3);
   SetIndexBuffer(0, g_ibuf_84);
   SetIndexStyle(0, DRAW_ARROW,0,2); 
   SetIndexArrow(0,234);  
   SetIndexBuffer(1, g_ibuf_88);
   SetIndexStyle(1, DRAW_ARROW,0,2); 
   SetIndexArrow(1,233);  
   SetIndexBuffer(2, g_ibuf_92);
   IndicatorShortName("K-J2_mod ("+Trend.Period+")");   
   return (0);
}

int deinit() {
DelOb();
   return (0);
}

int start() {
   double ld_12;
   double ld_20;
   double ld_28;
   int li_0 = IndicatorCounted();
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   int li_8 = MathMin(Bars - li_0, Bars - 1);
   for (int li_4 = li_8; li_4 >= 0; li_4--) {
      ld_12 = f0_0(High[li_4 + 1], Trend.Period, gi_80, li_4 + 1, 0);
      ld_20 = f0_0(Low[li_4 + 1], Trend.Period, gi_80, li_4 + 1, 10);
      ld_28 = f0_0(Close[li_4], Trend.Period, gi_80, li_4, 20);
      g_ibuf_92[li_4] = g_ibuf_92[li_4 + 1];
      if (ld_28 > ld_12) g_ibuf_92[li_4] = 1;
      if (ld_28 < ld_20) g_ibuf_92[li_4] = -1;
     
      if (g_ibuf_92[li_4] == -1) {
         g_ibuf_84[li_4] = 0.5;
         g_ibuf_88[li_4] = EMPTY_VALUE;
      } else if (g_ibuf_92[li_4] == 1){
         g_ibuf_84[li_4] = EMPTY_VALUE;
         g_ibuf_88[li_4] = 0.5;
      }
   }
  f0_2(); 
  for(int i=1; i<li_8; i++)
  { 
      if(ShowArrows)
      {
        if(g_ibuf_88[i] == 0.5 && g_ibuf_88[i+1]==EMPTY_VALUE)
        {
        DrawAr("up",i);
        }
        if(g_ibuf_84[i] == 0.5 && g_ibuf_84[i+1]==EMPTY_VALUE)
        {
        DrawAr("dn",i);
        }      
       }
   }    
   
   return (0);
}
//*****************
void DelOb()
{
    int n = ObjectsTotal();
    for (int i = n - 1; i >= 0; i--) 
    {
     string sName = ObjectName(i);
	  if (StringFind(sName, arrowsIdentifier) == 0) 
	  {
	    ObjectDelete(sName);
	  }
    }
}

//----------------------------------------------------------------------
void DrawAr(string ssName, int i)
{
    
    string sName=arrowsIdentifier+" "+ssName+" "+ TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
    ObjectDelete(sName);    
    ObjectCreate(sName, OBJ_ARROW, 0, Time[i], 0);
    double gap  = 3.0*iATR(NULL,0,20,i)/3.0;
    if(ssName=="up")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  233);
    ObjectSet(sName, OBJPROP_PRICE1, Low[i]-gap);
    ObjectSet(sName, OBJPROP_COLOR, arrowsUpColor);
    }
    if(ssName=="dn")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  234);
    ObjectSet(sName, OBJPROP_PRICE1, High[i]+gap);
    ObjectSet(sName, OBJPROP_COLOR, arrowsDnColor);    
    }    
    ObjectSet(sName, OBJPROP_WIDTH, 1);
}
//**********************************
 void f0_2() {
   int i;
   if (AlertOn) 
   {
      if (bar_0) i = 0;
      else i = 1;
      i = iBarShift(NULL, 0, iTime(NULL, 0, i));
         if(g_ibuf_88[i] == 0.5 && g_ibuf_88[i+1]==EMPTY_VALUE) f0_4(i, "(BUY)");
         if(g_ibuf_84[i] == 0.5 && g_ibuf_84[i+1]==EMPTY_VALUE) f0_4(i, "(SELL)");
   }
}

void f0_4(int i, string val) {
   string str_concat_12;
   if (gs_nothing_176 != val || g_time_184 != Time[i]) {
      gs_nothing_176 = val;
      g_time_184 = Time[i];
      str_concat_12 = StringConcatenate("K-J2_mod ", Symbol(), " ",Period()," " + val, " at ",  TimeToStr(TimeLocal(), TIME_MINUTES));
      Alert(str_concat_12);

   }
}
//*****************
double f0_0(double ad_0, double ad_8, double ad_16, int ai_24, int ai_28 = 0) {
   double ld_80;
   double ld_88;
   if (ArrayRange(gda_96, 0) != Bars) ArrayResize(gda_96, Bars);
   int li_32 = Bars - ai_24 - 1;
   if (li_32 == 0) {
      for (int count_36 = 0; count_36 < 7; count_36++) gda_96[0][count_36 + ai_28] = ad_0;
      while (count_36 < 10) {
         gda_96[0][count_36 + ai_28] = 0;
         count_36++;
      }
      return (ad_0);
   }
   double ld_40 = MathMax(MathLog(MathSqrt((ad_8 - 1.0) / 2.0)) / MathLog(2.0) + 2.0, 0);
   double ld_48 = MathMax(ld_40 - 2.0, 0.5);
   double ld_56 = ad_0 - (gda_96[li_32 - 1][ai_28 + 5]);
   double ld_64 = ad_0 - (gda_96[li_32 - 1][ai_28 + 6]);
   gda_96[li_32][ai_28 + 7] = 0;
   if (MathAbs(ld_56) > MathAbs(ld_64)) gda_96[li_32][ai_28 + 7] = MathAbs(ld_56);
   if (MathAbs(ld_56) < MathAbs(ld_64)) gda_96[li_32][ai_28 + 7] = MathAbs(ld_64);
   gda_96[li_32][ai_28 + 8] = gda_96[li_32 - 1][ai_28 + 8] + (gda_96[li_32][ai_28 + 7] - (gda_96[li_32 - 10][ai_28 + 7])) / 10.0;
   double ld_72 = MathMin(MathMax(4.0 * ad_8, 30), 150);
   if (li_32 < ld_72) {
      ld_80 = gda_96[li_32][ai_28 + 8];
      for (count_36 = 1; count_36 < ld_72 && li_32 - count_36 >= 0; count_36++) ld_80 += gda_96[li_32 - count_36][ai_28 + 8];
      ld_80 /= count_36;
   } else ld_80 = ((gda_96[li_32 - 1][ai_28 + 9]) * ld_72 - (gda_96[li_32 - f0_1(ld_72)][ai_28 + 8]) + (gda_96[li_32][ai_28 + 8])) / ld_72;
   gda_96[li_32][ai_28 + 9] = ld_80;
   if (gda_96[li_32][ai_28 + 9] > 0.0) ld_88 = (gda_96[li_32][ai_28 + 7]) / (gda_96[li_32][ai_28 + 9]);
   else ld_88 = 0;
   if (ld_88 > MathPow(ld_40, 1.0 / ld_48)) ld_88 = MathPow(ld_40, 1.0 / ld_48);
   if (ld_88 < 1.0) ld_88 = 1.0;
   double ld_96 = MathPow(ld_88, ld_48);
   double ld_104 = MathSqrt((ad_8 - 1.0) / 2.0) * ld_40;
   double ld_112 = MathPow(ld_104 / (ld_104 + 1.0), MathSqrt(ld_96));
   if (ld_56 > 0.0) gda_96[li_32][ai_28 + 5] = ad_0;
   else gda_96[li_32][ai_28 + 5] = ad_0 - ld_112 * ld_56;
   if (ld_64 < 0.0) gda_96[li_32][ai_28 + 6] = ad_0;
   else gda_96[li_32][ai_28 + 6] = ad_0 - ld_112 * ld_64;
   double ld_120 = MathMax(MathMin(ad_16, 100), -100) / 100.0 + 1.5;
   double ld_128 = (ad_8 - 1.0) / 2.0 / ((ad_8 - 1.0) / 2.0 + 2.0);
   double ld_136 = MathPow(ld_128, ld_96);
   gda_96[li_32][ai_28 + 0] = ad_0 + ld_136 * (gda_96[li_32 - 1][ai_28 + 0] - ad_0);
   gda_96[li_32][ai_28 + 1] = (ad_0 - (gda_96[li_32][ai_28 + 0])) * (1 - ld_128) + ld_128 * (gda_96[li_32 - 1][ai_28 + 1]);
   gda_96[li_32][ai_28 + 2] = gda_96[li_32][ai_28 + 0] + ld_120 * (gda_96[li_32][ai_28 + 1]);
   gda_96[li_32][ai_28 + 3] = (gda_96[li_32][ai_28 + 2] - (gda_96[li_32 - 1][ai_28 + 4])) * MathPow(1 - ld_136, 2) + MathPow(ld_136, 2) * (gda_96[li_32 - 1][ai_28 + 3]);
   gda_96[li_32][ai_28 + 4] = gda_96[li_32 - 1][ai_28 + 4] + (gda_96[li_32][ai_28 + 3]);
   return (gda_96[li_32][ai_28 + 4]);
}

int f0_1(double ad_0) {
   return (ad_0);
}